import Process
import Control.Monad

main1 = runP ( producer |> transformer |> consumer )

main2 = runP ( producer |>>> multiple 2 |> multiple 3 |>>> consumer )

main3 = do
  let pipe = case [2,4] of
               [x] -> multiple x
               [x,y] -> multiple x |> multiple y
               [x,y,z] -> multiple x |> multiple y |> multiple z
               _         -> \handle -> fail "Zero or too much multipliers"
  runP ( producer |> pipe |> consumer )

main = do
  handle <- runAsyncP (multiple 2)
  sendP handle 1
  res <- receiveP handle
  print res
  handle1 <- runAsyncP ( producer |> transformer )
  handle2 <- runAsyncP (             transformer |> consumer )
  handle3 <- runAsyncP ( producer |> transformer |> consumer )
  joinP handle3
  killP handle2  -- demonstrates bug in library :(

main5 = do
  runFuncP transformer
    readLn        -- input action
    undefined
    print         -- output action
    undefined



producer handle = mapM_ (sendP handle) [1..10]

transformer handle = replicateM_ 10 $
                       do x <- receiveP handle
                          sendP handle (x*2)

consumer handle = replicateM_ 10 $
                    do x <- receiveP handle
                       print x

multiple n handle = replicateM_ 10 $
                      do x <- receiveP handle
                         sendP handle (x*n)

transformer2 handle =
  runFuncP ( multiple 2 |> multiple 3 )
    (receiveP handle)
    (send_backP handle)
    (sendP handle)
    (receive_backP handle)

consumer2 handle =
  runFuncP ( multiple 4 )
    (receiveP handle)
    undefined
    print             -- output action
    undefined
